#include "../KOSMA_file_io.h"

int main()
{
  int i;

  STRING_VAR author;  /* scalar */
  STRING_VAR rx_name[2];  /* 1D-array */
  DOUBLE_VAR f_rest[2];  /* 1D-array */
  DOUBLE_VAR f_synth[2];  /* 1D-array */
  STRING_VAR aos_name[4];  /* 1D-array */
  INT_VAR n_channel[4];  /* 1D-array */

  /* Display only errors in the categories FATAL ... WARNING */
  DebugLevel( FATAL - WARNING, FATAL - INFO );

  /* Set an error log file */
  ErrorLogfile( "file_io.dbg" );

  /* adds filename and line number info to messages, if activated */
  SetErrorFormat( "long" );
  SetErrorFormat( "" ); /* standard short error messages */

  /* set standard config file name */
  StandardConfigFile( __FILE__ );

  /* Configure variables */
  ConfigureString( &author, "Author", "", "" );
  ConfigureString( rx_name,"Receiver_name", "", "2" );
  ConfigureDouble( f_rest, "Rest_Frequency", "", "2" );
  ConfigureDouble( f_synth, "Synthesizer_Frequency", "", "2" );
  /* Configure the variable from alternative config file */
  ConfigureString( aos_name, "AOS_name", "aos.cfg", "4" );
  /* set new default config file */
  DefineConfigFile( "aos.cfg" );
  ConfigureInt( n_channel, "channel_number", "", "4" );

  /* Increase debug level to FATAL ... DEBUG */
  DebugLevel( FATAL - DEBUG, FATAL - DEBUG );

  /* Read variables from input files ^*/
  ReadAllVariables();
  printf( "\n" );
  /* Read variables again to demonstrate effect of old time stamp */
  ReadAllVariables();

  for (i=0; i<2; i++)
    f_synth[i].value = f_rest[i].value / 46.;

  /* try out legal things... */
  printf( "\nReading a var_set: \n" );
  ReadVariablesVarSet( &f_rest[0].name );
  printf( "\nWriting a var_set: \n" );
  WriteVariablesVarSet( &n_channel[0].name );

  /* try out ILLEGAL things... */
  printf( "\nReading a write-only variable: \n" );
  ReadVariablesVarSet( &f_synth[0].name );
  printf( "\nWriting a read-only variable: \n" );
  WriteVariablesVarSet( &aos_name[0].name );

  printf( "\nList a few variables:\n" );
  for (i=0; i<4; i++)
    printf( "Name of AOS-channel #%d: %s\n", i, aos_name[i].value );

  /* write variables to output files */
  WriteAllVariables();

  ErrorLogfile( "" );

  exit( 0 );
}
